//----------------------------------------------------------------
// GUI main Frame
// Programmr: Bjrk Busch nov.1999/2002
//----------------------------------------------------------------

import javabook.Convert;
import java.awt.*;
import java.awt.event.*;

public	class GuiMainFrame extends Frame
{
  // Skrmdata
  private MenuBar    menuBar        = new MenuBar();
  private Menu       menuAlm        = new Menu("Alm. regneoperationer");
  private MenuItem   itemAlmAdd     = new MenuItem("Add");
  private MenuItem   itemAlmSub     = new MenuItem("Sutract");

  private Menu       menuDiv        = new Menu("Diverse funktioner");
  private MenuItem   itemDivClear   = new MenuItem("Clear");

  private Label      displayLabel   = new Label ("Display:");
  private TextField  display        = new TextField ("",50);

  // Modelkomponent 
  Regnemaskine       regnemaskine   = new Regnemaskine();


  public GuiMainFrame ()			/* constructor */
  {
    // opbygning af skrmbillede
    setSize(600,200);
    setTitle("Regnemaskine komponent med grafisk brugergrnseflade  -  Systemeksempel udarbejdet af Bjrk Busch");

    setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));		


    setMenuBar(menuBar);

    menuBar.add(menuAlm);

    menuAlm.add(itemAlmAdd);
    itemAlmAdd.addActionListener(new AddActionListener());

    menuAlm.add(itemAlmSub);
    itemAlmSub.addActionListener(new SubActionListener());


    menuBar.add(menuDiv);

    menuDiv.add(itemDivClear);
    itemDivClear.addActionListener(new ClearActionListener());

    add(displayLabel);
    add(display);

    display.setText(""+regnemaskine.readDisplay());

  }

  private	void add ()
  {
    regnemaskine.setDisplay(Convert.toInt(display.getText()));
    regnemaskine.add();
    display.setText(""+regnemaskine.readDisplay());
  }
  private	void subtract ()
  {
    regnemaskine.setDisplay(Convert.toInt(display.getText()));
    regnemaskine.subtract();
    display.setText(""+regnemaskine.readDisplay());
  }
  private	void  clear ()
  {
    regnemaskine.clear();
    display.setText(""+regnemaskine.readDisplay());
  }

  //==============================================================================
  // Event handler
  private	class AddActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      add ();
    }
  }

  private	class SubActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      subtract ();
    }
  }

  private	class ClearActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      clear ();
    }
  }


} // slut p frame-klasse
